<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8" />
  <title>ITEA-JS ADVANCED - LESSON 2: CLASSWORK 2</title>
  <link rel="stylesheet" href="css/style.min.css" />
</head>
<body>
  <div class="wrap">
    <div class="testBlock hover">
      <button class="iButton" id="mouseHover">1. Hover!</button>
      <ul id="hoverResult" class="resultBlock"></ul>
    </div>

    <div class="testBlock click">
      <button class="iButton" id="mouseClick">2. Click for do things</button>
      <div id="clickResult" class="resultBlock one two three four five six"></div>
    </div>

    <div class="testBlock random">
      <button class="iButton" id="mouseLight">3. Click for turn on lights</button>
      <div id="lightResult" class="resultBlock"></div>
    </div>

    <div class="testBlock keyboard">
      <button class="iButton" id="keyboardButton">4. Press any key</button>
      <div id="keyboardResult" class="resultBlock key-colors"></div>
    </div>

  </div>

  <script>
    /*

      Поработаем немного с ивентами:
      onmouseenter
      onclick
      oncontextmenu
      onkeydown

      Задание:
      На каждую из конопок назначить действие которое будет выполнять следующее действие:
      1.На ховер(onmouseenter) повесить обработчик который будет при каждом наведении
        на кнопку будет выводить в блок результатом елемент li с текстом "hovered!"
        у которого будет один из следующих класов:
        red blue green orange purple

      2.На кнопку клика(onclick) повесить обработчик который будет удалять классы с
        блока с результатом по очереди в таком порядке:

        six > two > three > four > one > five

        после того как блок окажется пустым, добавить их в порядке возрастания

        one > two > three ... > six

      3. На кнопку клика (Light) повесить обработчик, который будет выводить в 
      блок с результатом (lightResult) поочередно один из цветов светофора:
      Цикл: Off -> Red -> Yellow -> Green -> Off

      4. На кнопку с обработчиком нажатия (onkeydown) повесить обработчик который будет:

        - Выводить в блок с результатом(keyboardResult) число нажатий на любую из клавиш клавиатуры.
        - Давать блоку (keyboardResult) классы, которые соотсветствуют числу кликов:

        Н-р:
        1 -> one
        3 -> three
        5 -> five
        11 -> one one
        115 -> one one five



    */

    var mouseHover = document.getElementById('mouseHover');
    var mouseClick = document.getElementById('mouseClick');
    var mouseLight = document.getElementById('mouseLight');
    var keyboardButton = document.getElementById('keyboardButton');
    // 1 #######################
    mouseHover.onmouseenter = function() {
      const hoverResult = document.getElementById('hoverResult');
      const items = ['red', 'blue', 'orange', 'purple'];

      function random_item(items) {
        return items[Math.floor(Math.random() * items.length)];
      }
      hoverResult.insertAdjacentHTML('beforeend', `<li class="${random_item(items)}">Hovered!</li>`);
      const li = hoverResult.querySelectorAll('li');
      if(li.length > 5){
        alert('You exceed the limit!');
        hoverResult.innerHTML = '';
      }
    }
    // 2 #####################
    var clickIndex = 0;
    var direction = true;
    let arrayDelete = ['six', 'two', 'three', 'four', 'one', 'five'];
    let arrayWrite = ['one', 'two', 'three', 'four', 'five', 'six'];
    let arrayReserve = [];
    mouseClick.onclick = function() {
      const clickResult = document.getElementById('clickResult');
      if(direction) {
        if(clickResult.classList.value.split(' ').includes(arrayDelete[0]) && arrayDelete.length > 0) {
          arrayReserve.push(arrayDelete[0]);
          clickResult.classList.remove(arrayDelete[0]);
          arrayDelete.shift();
        } else {
          arrayDelete = [...arrayReserve];
          arrayReserve.splice(0, arrayReserve.length);
          direction = false;
        }
      }
      if(!direction) {
        if(!clickResult.classList.value.split(' ').includes(arrayWrite[0]) && arrayWrite.length > 0) {
          arrayReserve.push(arrayWrite[0]);
          clickResult.classList.add(arrayWrite[0]);
          arrayWrite.shift();
        } else {
          arrayWrite = [...arrayReserve];
          arrayReserve.splice(0, arrayReserve.length);
          direction = true;
        }
      }
    }

    // 3 ####################
    const lightsArray = ['Off','Red','Yellow','Green','Off'];
    const lightResult = document.getElementById('lightResult');
    let ite = 0;
    mouseLight.onclick = function(e){
      if(lightsArray.length > ite){
        lightResult.classList.add(lightsArray[ite].toLowerCase());
        lightResult.style.backgroundColor = (lightsArray[ite].toLowerCase() === 'off') ? 'grey': lightsArray[ite].toLowerCase();
        lightResult.innerHTML = `${lightsArray[ite]}`;
      }else {
        ite = 0;
      }
      ite++;
    }
    // 4 ##################
    var counter = 0;
    const digit = [];
    const keyboardResult = document.getElementById('keyboardResult');

    keyboardButton.onkeydown = function(e){
      let number = transformLetterToDigit(e.key);
      try{
        keyboardResult.classList.add(number);
        keyboardResult.innerHTML = number;
      }catch(e){
        keyboardResult.innerHTML = `Error: ${number}`;
      }
    }

    function transformLetterToDigit(letter){
      switch(letter){
        case '1':
          return 'one'
          break;
        case '2':
          return 'two'
          break; 
        case '3':
          return 'three'
          break;
        case '4':
          return 'four'
          break; 
        case '5':
          return 'five'
          break; 
        case '6':
          return 'six'
          break;
        case '7':
          return 'seven'
          break; 
        case '8':
          return 'eight'
          break; 
        case '9':
          return 'nine'
          break; 
        case '0':
          return 'zero'
          break;
        default:
          return 'You pushed not the number!'
          break;     
          
      }
    }
  </script>
</body>
</html>
